// mylib.c
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char* hello() {
    return "Hello, World!";
}

char* helloName(const char *name) {
    char *result = (char *)malloc(strlen(name) + 9);
    if (result) {
        sprintf(result, "Hello, %s!", name);
    }
    return result;
}

void helloPtr(char *result) {
    sprintf(result, "Hello, World!");
}

void helloPtrPtr(char **result, size_t *size) {
    const char *message = "Hello, World!";
    *size = strlen(message) + 1; // +1 for null terminator
    *result = (char *)malloc(*size);
    if (*result) {
        strcpy(*result, message);
    }
}

void helloVoidPtrPtr(void **result, size_t *size) {
    const char *message = "Hello, World!";
    *size = strlen(message) + 1; // +1 for null terminator
    *result = malloc(*size);
    if (*result != NULL) {
        strcpy((char *)*result, message);
    }
}

int add(int a, int b) {
    return a + b;
}

// Add function returning result in a pointer
void addPtr(int a, int b, int *result) {
    *result = a + b;
}

void fillHexValues(void **result, size_t *size) {
    unsigned char values[5] = {0x05, 0xE7, 0x02, 0x00, 0x00};

    *size = sizeof(values);
    *result = malloc(*size);
    if (*result != NULL) {
        memcpy(*result, values, *size);
    }
}
